/*
    $Id: 
 
    Desc:
    Lang: english
*/

#include <exec/memory.h>
#include <exec/tasks.h>
#include <exec/execbase.h>
#include <dos/dosextens.h>
#include <dos/exall.h>
#include <proto/exec.h>
#include <proto/dos.h>
#include <aros/machine.h>

#include "portlist_version.h"

static const char version[] = VERSTAG;

struct port
{
    STRPTR name;
    APTR address;
    ULONG sigbit;
    struct Task *sigtask;
    STRPTR sigtaskname;
};


static int fillbuffer(struct port **buffer, IPTR size, struct ExecBase *SysBase);

int main(void)
{
    struct ExecBase		*SysBase;
    struct DosLibrary	*DOSBase;
    IPTR size;
    struct port *buffer,*ports,*ports2;
    LONG error=RETURN_OK;

    SysBase = *((struct ExecBase**) 4);
    if ((DOSBase=(struct DosLibrary *)OpenLibrary("dos.library",37))!=0)
    {
        for(size=2048;;size+=2048)
        {
            buffer=AllocVec(size,MEMF_ANY);
            if(buffer==NULL)
            {
                error=RETURN_FAIL;
                break;
            }
            ports=buffer;
            if (fillbuffer(&ports,size,SysBase))
            {
                IPTR args[6];
                args[0] = (IPTR) "Address";
                args[1] = (IPTR) "Name";
                args[2] = (IPTR) "Signal";
                args[3] = (IPTR) "Task";
                args[4] = (IPTR) "TaskName";

                VPrintf("%10s\t%30s\t%2s\t%10s\t%30s\n", args);
                FPuts(Output(),
                      "------------------------------------------------------------------------------------------------------\n");
                for(ports2=buffer;ports2<ports;ports2++)
                {
                    args[0] = (IPTR)ports2->address;
                    args[1] = (IPTR)ports2->name;
                    args[2] = (IPTR)ports2->sigbit;
                    args[3] = (IPTR)ports2->sigtask;
                    args[4] = (IPTR) ports2->sigtaskname;
                    VPrintf("0x%08.lx\t%30s\t%2ld\t0x%lx\t%30s\n", args);
                    if(SetSignal(0L,SIGBREAKF_CTRL_C) & SIGBREAKF_CTRL_C)
                    {
                        error = RETURN_FAIL;
                        SetIoErr(ERROR_BREAK);
                        break;
                    }
                }
                FreeVec(buffer);
                break;
            }
            FreeVec(buffer);
        }
        if (error != RETURN_OK)
        {
            PrintFault(IoErr(), NULL);
        }
        CloseLibrary((struct Library *)DOSBase);
    }

    return error;
}

static int addport(struct MsgPort *myport, struct port **l, STRPTR *e)
{
    STRPTR s1, s2;

    (*l)->address  = myport;
    (*l)->sigbit  = myport->mp_SigBit;
    (*l)->sigtask = myport->mp_SigTask;

    s1 = myport->mp_Node.ln_Name;

    if(s1!=NULL)
    {
        s2=s1;
        while(*s2++)
            ;
        while(s2>s1)
        {
            if(*e<=(STRPTR)(*l+2))
                return 0;
            *--(*e)=*--s2;
        }
    }
    if((STRPTR)(*l+2)>*e)
        return 0;

    (*l)->name=*e;

    if (myport->mp_SigTask)
    {
      s1 = ((struct Task*)myport->mp_SigTask)->tc_Node.ln_Name;

      if(s1!=NULL)
      {
          s2=s1;
          while(*s2++)
              ;
          while(s2>s1)
          {
              if(*e<=(STRPTR)(*l+2))
                  return 0;
              *--(*e)=*--s2;
          }
      }
      if((STRPTR)(*l+2)>*e)
          return 0;

      (*l)->sigtaskname=*e;
    }
    else
    {
      (*l)->sigtaskname = NULL;
    }


    ++*l;

    return 1;
}

static int fillbuffer(struct port **buffer, IPTR size, struct ExecBase *SysBase)
{
    STRPTR end=(STRPTR)*buffer+size;
    struct MsgPort *myport;
    int ret=1;
    Forbid();
    for(myport=(struct MsgPort *)SysBase->PortList.lh_Head;
            myport->mp_Node.ln_Succ!=NULL && ret;
            myport=(struct MsgPort *)myport->mp_Node.ln_Succ)
        ret=addport(myport,buffer,&end);
    Permit();
    return ret;
}

